
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <fcntl.h>

#include "posix_Constants.h"

static void setStaticInt(JNIEnv *env, jclass cls, char *name, int value) {
  jfieldID fid;

  fid = (*env)->GetStaticFieldID(env, cls, name, "I");
  (*env)->SetStaticIntField(env, cls, fid, value);
}

/*
 * Class:     posix_File
 * Method:    initialiseConstants
 * Signature: ()V
 * Result:    The Posix constants are set in Java vbls
 */
JNIEXPORT void JNICALL Java_posix_Constants_initialiseStatConstants
  (JNIEnv *env, jclass cls)
{
  jfieldID fid;

  /* file permissions */
  setStaticInt(env, cls, "s_irwxu", S_IRWXU);
  setStaticInt(env, cls, "s_irusr", S_IRUSR);
  setStaticInt(env, cls, "s_iwusr", S_IWUSR);
  setStaticInt(env, cls, "s_ixusr", S_IXUSR);
  setStaticInt(env, cls, "s_irwxg", S_IRWXG);
  setStaticInt(env, cls, "s_irgrp", S_IRGRP);
  setStaticInt(env, cls, "s_iwgrp", S_IWGRP);
  setStaticInt(env, cls, "s_ixgrp", S_IXGRP);
  setStaticInt(env, cls, "s_irwxo", S_IRWXO);
  setStaticInt(env, cls, "s_iroth", S_IROTH);
  setStaticInt(env, cls, "s_iwoth", S_IWOTH);
  setStaticInt(env, cls, "s_ixoth", S_IXOTH);
  setStaticInt(env, cls, "s_isuid", S_ISUID);
  setStaticInt(env, cls, "s_isgid", S_ISGID);
}

dummy(JNIEnv *env, jclass cls)
{
  jfieldID fid;

  /* access constants */
  setStaticInt(env, cls, "r_ok", R_OK);
  setStaticInt(env, cls, "w_ok", W_OK);
  setStaticInt(env, cls, "x_ok", X_OK);
  setStaticInt(env, cls, "f_ok", F_OK);

  /* file contants */
  setStaticInt(env, cls, "o_rdonly", O_RDONLY);
  setStaticInt(env, cls, "o_wronly", O_WRONLY);
  setStaticInt(env, cls, "o_rdwr", O_RDWR);
  setStaticInt(env, cls, "o_append", O_APPEND);
  setStaticInt(env, cls, "o_creat", O_CREAT);
  setStaticInt(env, cls, "o_excl", O_EXCL);
  setStaticInt(env, cls, "o_noctty", O_NOCTTY);
  setStaticInt(env, cls, "o_nonblock", O_NONBLOCK);
  setStaticInt(env, cls, "o_trunc", O_TRUNC);

}





