
#include "Fields.h"

void setStaticInt(JNIEnv *env, jclass cls, char *name, int value) {
  jfieldID fid;

#ifdef DEBUG
  fprintf(stderr, "Setting static int %s\n", name);
#endif

  fid = (*env)->GetStaticFieldID(env, cls, name, "I");
  (*env)->SetStaticIntField(env, cls, fid, value);
}


void setIntField(JNIEnv *env, jobject obj, char *name, int value)
{
  /* get file descriptor Java id */
  jclass class = (*env) -> GetObjectClass(env, obj);
  jfieldID jfid = (*env) -> GetFieldID(env, class, name, "I");
  (*env) -> SetIntField(env, obj, jfid, value);

}

/*
void setStringField(JNIEnv *env, jobject obj, char *name, char *msg)
{
}
*/

int getIntField(JNIEnv *env, jobject obj, char *name)
{
  int value;
  /* get file descriptor Java id */
  jclass class = (*env) -> GetObjectClass(env, obj);
  jfieldID jfid = (*env) -> GetFieldID(env, class, name, "I");
  value = (*env) -> GetIntField(env, obj, jfid);

}

stringFieldStruct getStringField(JNIEnv *env, jobject obj, char *name)
{
  jclass class;
  jfieldID jfid;
  jstring jstr;
  char *str;
  stringFieldStruct s;

  class = (*env) -> GetObjectClass(env, obj); 
#ifdef DEBUG 
  fprintf(stderr, "got class\n");
#endif
  jfid = (*env)->GetFieldID(env, class, 
				     name, "Ljava/lang/String;");
#ifdef DEBUG
  fprintf(stderr, "got jfield ID\n");
#endif

  jstr = (*env)->GetObjectField(env, obj, jfid);
#ifdef DEBUG
  fprintf(stderr, "got object field\n");
#endif

  str  = (*env)->GetStringUTFChars(env, jstr, 0);
#ifdef DEBUG
  fprintf(stderr, "got string\n");
#endif

  s.str = str;
  s.jstr = jstr;
  return s;
}

void setStringField(JNIEnv *env, jobject obj, 
		    char *name, char *value)
{
  jclass class;
  jfieldID jfid;
  jstring jstr;
  char *str;
  stringFieldStruct s;

  class = (*env) -> GetObjectClass(env, obj); 
#ifdef DEBUG 
  fprintf(stderr, "got class\n");
#endif
  jfid = (*env)->GetFieldID(env, class, 
				     name, "Ljava/lang/String;");
#ifdef DEBUG
  fprintf(stderr, "got jfield ID\n");
#endif

  jstr = (*env)->NewStringUTF(env, value);
  (*env)->SetObjectField(env, obj, jfid, jstr);

  /* cleanup */
}
