/**
 * Posix class Pipe.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */


package posix;

public class Pipe {

    protected OpenFile pfd[];

    /**
     * Create a new pipe
     * @exception PosixException EMFILE, ENFILE
     */
    public Pipe() throws PosixException {
	pfd = new OpenFile[2];
	pfd[0] = new ReadFile();
	pfd[1] = new WriteFile();

	pipe(pfd);
    }

    /**
     * Create a new pipe
     * @exception PosixException EMFILE, ENFILE
     */
    protected native int pipe(OpenFile pfd[]);

    public ReadFile in() {
	// should this be a copy?
	return (ReadFile) pfd[0];
    }

    public WriteFile out() {
	return (WriteFile) pfd[1];
    }
}
