/**
 * Posix class Posix.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */



package posix;

/**
 * contains standard Posix objects
 */

public class Posix {

    /**
     * the standard input stream, on file descriptor 0
     */
    public final static ReadFile stdin = new ReadFile();

    /**
     * the standard output stream, on file descriptor 1
     */
    public final static WriteFile stdout = new WriteFile();

    /**
     * the standard error stream, on file descriptor 2
     */
    public final static WriteFile stderr = new WriteFile();

    static {
	stdin.fd = 0;
	stdout.fd = 1;
	stderr.fd = 2;
    }
}
