/**
 * Posix class PosixException.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */



package posix;

public class PosixException extends Exception {

    // error numbers from errno.h
    // public static final int ENOACCES;

    protected int errno;
    protected String errmsg;

    protected static native void initializeConstants();

    /**
     * return the error number
     */
    public int getErrno() {
	return errno;
    }

    /**
     * return the error message
     */
    public String getErrmsg() {
	return errmsg;
    }

    /**
     * return a string representation of the exception
     */
    public String toString() {
	return "errno " + errno + " - " + getMessage();;
    }
}



