/**
 * Posix class ReadFile.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */



package posix;

public class ReadFile extends OpenFile {

    ReadFile() {
	// empty - only used for stdin
    }

    /**
     * Open a file for reading.
     * @exception PosixException EACCESS, EEXIST, EINTR,
     * EISDIR, EMFILE, ENAMETOOLONG, ENFILE, ENOENT,
     * ENOSPEC, ENOTDIR, ENXIOM EROFS.
     */
    public ReadFile(String path) throws PosixException {
	super(path);
	open(path, RDONLY);
    }

     /**
     * Open a file for reading.
     * @exception PosixException EACCESS, EEXIST, EINTR,
     * EISDIR, EMFILE, ENAMETOOLONG, ENFILE, ENOENT,
     * ENOSPEC, ENOTDIR, ENXIOM EROFS.
     */
    public ReadFile(String path, int flag) throws PosixException {
	super(path);
	open(path, flag);
    }

    /**
     * Read from the file
     * @exception PosixException EAGAIN, EBADF, EINTR, EIO
     */
    public int read(byte[] buf) throws PosixException {
	return read(buf, buf.length);
    }

    /**
     * Read from the file
     * @exception PosixException EAGAIN, EBADF, EINTR, EIO
     */
    public native int read(byte[] buf, int nbyte)
	 throws PosixException;
}
