/**
 * Posix class WriteFile.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */

package posix;

public class WriteFile extends OpenFile {
    WriteFile() {
	// empty  only used by Posix for stdout, stderr
    }

    /**
     * Open the file for writing.
     * @exception PosixException EACCESS, EEXIST, EINTR,
     * EISDIR, EMFILE, ENAMETOOLONG, ENFILE, ENOENT,
     * ENOSPEC, ENOTDIR, ENXIOM EROFS.
     */
    public WriteFile(String path) throws PosixException {
	super(path);
	open(path, (WRONLY | TRUNC));
    }

   /**
     * Open the file for writing.
     * @exception PosixException EACCESS, EEXIST, EINTR,
     * EISDIR, EMFILE, ENAMETOOLONG, ENFILE, ENOENT,
     * ENOSPEC, ENOTDIR, ENXIOM EROFS.
     */
    public WriteFile(String path, int flag) 
	throws PosixException {
	super(path);
	open(path, flag);
    }

   /**
     * Open the file for writing.
     * @exception PosixException EACCESS, EEXIST, EINTR,
     * EISDIR, EMFILE, ENAMETOOLONG, ENFILE, ENOENT,
     * ENOSPEC, ENOTDIR, ENXIOM EROFS.
     */
    public WriteFile(String path, int flag, int mode) 
	throws PosixException {
	super(path);
	open(path, flag, mode);
    }

    /**
     * Write to the file
     * @exception PosixException EAGAIN, EBADF, EFBIG,
     * EINTR, EIO, ENOSPEC, EPIPE
     */
    public int write(byte[] buf) throws PosixException {
	return write(buf, buf.length);
    }

    /**
     * Write to the file
     * @exception PosixException EAGAIN, EBADF, EFBIG,
     * EINTR, EIO, ENOSPEC, EPIPE
     */
    public native int write(byte[] buf, int nbyte)
	 throws PosixException;

}
