/**
 * Posix test class TestDup2.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */


import posix.WriteFile;
import posix.Posix;
import posix.PosixException;

/**
 * Tests OpenFile method dup2.
 * Requires files/f1, files/f2.
 */
public class TestDup2 {

    static public void main(String argv[]) {
	System.loadLibrary("java_posix");
        new TestDup2();
    }

    public TestDup2() {
	boolean error = false;
	WriteFile f1 = null;
	WriteFile f2 = null;

	try {
	    f1 = new WriteFile("files/f1");
	    f2 = new WriteFile("files/f2");

	    f1.dup2(f2);

	    f2.close();
	} catch(PosixException e) {
	    System.out.println(e.toString());
	}

        byte outbuf[] = {'a', 'b', 'c', 'd', 'e', 'f'};
 
	// this should go to TestFile.java.copy
        try {
	    int len = f1.write(outbuf, outbuf.length);
	} catch(Exception e) {
	    System.out.println(e.toString());
	}

	try {
	    f1.close();
	} catch(Exception e) {
	    System.out.println("close failed");
	}
    }
}
