/**
 * Posix test class TestFile.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */

import posix.File;

/**
 * Test File class
 * Tests unlink, link, rename.
 * Assumes existence of files/f1, files/f2
 * but no files/f3
 */
public class TestFile {

    static public void main(String argv[]) {
	System.loadLibrary("java_posix");
	new TestFile();
    }

    public TestFile() {
	boolean error = false;

	// File.umask(1);
	try {
	    File testbak = new File("files/f1");
	    testbak.unlink();
	} catch(Exception e) {
	    System.out.println("Unlink failed");
	    error = true;
	}

	try {
	    File test = new File("files/f2");
	    test.link("files/f1");
	} catch(Exception e) {
	    System.out.println("Link failed");
	    error = true;
	}


	try {
	    File test = new File("files/f1");
	    test.rename("files/f3");
	    test.rename("files/f1");
	} catch(Exception e) {
	    System.out.println("Link failed");
	    error = true;
	}

	if (error) {
	    System.out.println("File: tests failed");
	} else {
	    System.out.println("File: tests passed");
	}
    }
}
