/**
 * Posix test class TestFork.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */

import posix.Process;
import posix.Pipe;
import posix.OpenFile;
import posix.Posix;

public class TestFork {

    static public void main(String argv[]) {
        System.loadLibrary("java_posix");

	Pipe pfd = new Pipe();

	try {
	    if (Process.fork() == 0) {
		pfd.out().close();
		pfd.in().dup2(Posix.stdin);
		pfd.in().close();
		
		String args[] = new String [] {"wc"};
		Process.execvp("wc", args);
	    } else {
		pfd.in().close();
		pfd.out().dup2(Posix.stdout);
		pfd.out().close();

		String args[] = new String [] {"ls"};
		Process.execvp("ls", args);
	    }
	} catch(Exception e) {
		System.out.println(e.toString());
	}
    }
}
