/**
 * Posix test class TestPipe.
 *
 * @version     1.0 20/6/98
 * @author      Jan Newmarch.
 * Copyright &copy; Jan Newmarch.
 * Covered by GNU Library General Public License
 */

import posix.OpenFile;
import posix.ReadFile;
import posix.WriteFile;
import posix.Pipe;

/**
 * Tests class Pipe.
 */
public class TestPipe {

    static public void main(String argv[]) {
        System.loadLibrary("java_posix");
        new TestPipe();
    }

    public TestPipe() {
        boolean error = false;
	Pipe p = new Pipe();
	ReadFile in = p.in();
	WriteFile out = p.out();

	byte outbuf[] = {'a', 'b', 'c'};
	byte inbuf[] = new byte[outbuf.length];

	try {
	    out.write(outbuf, outbuf.length);
	    out.close();
	    in.read(inbuf, inbuf.length);
	} catch(Exception e) {
	    System.out.println(e.toString());
	    error = true;
	}

	for (int n = 0; n < outbuf.length; n++) {
	    if (inbuf[n] != outbuf[n]) {
		System.out.println("in: " + inbuf[n] +
				   " out: " + outbuf[n]);
		error = true;
	    }
	}
	
        if (error) {
            System.out.println("TestPipe: tests failed");
        } else {
            System.out.println("TestPipe: tests passed");
        }

    }
}
	
