
import posix.ReadFile;
import posix.WriteFile;
import posix.Posix;
import java.lang.Runtime;
import java.lang.Process;

public class TestReadFile {

    static public void main(String argv[]) {
        System.loadLibrary("java_posix");
        new TestReadFile();
    }

    public TestReadFile() {
	ReadFile in = null;
	WriteFile out = null;
	boolean error = false;

	try {
	    in = new ReadFile("Makefile");
	    out = new WriteFile("Makefile.copy");
	} catch(Exception e) {
	    System.out.println("Couldn't open files. " +
			       e.toString());
	}
	byte buf[] = new byte[1024];
	int nread;

	System.out.println("Reading...");
	while ((nread = in.read(buf)) > 0) {
	    System.out.println("Writing " + nread);
	    out.write(buf, nread);
	}
	try {
	    in.close();
	    out.close();
	} catch(Exception e) {
	    System.out.println("Couldn't close files. " +
			       e.toString());
	}

	// see if the two are the same
	try {
	    Process p = Runtime.getRuntime().exec(
				 "cmp Makefile Makefile.bak");
	    if (p.waitFor() != 0) {
		System.out.println("Copy using read/write failed");
	    }
	} catch(Exception e) {
	    System.out.println("Couldn't create check process " +
			       e.toString());
	}

	// now test stdin/stdout
	System.out.println("Type upto 128 chars");
	nread = Posix.stdin.read(buf);
	Posix.stdout.write(buf, nread);
    }
}
